<script setup lang="ts"></script>

<template>
  <main>
    <h1>Setup</h1>
    <h2>Ambition</h2>
    <p>Provide a low level introduction to GraphQL<br />There is so much more to discover!</p>
    <h2>Prerequisites</h2>
    <ul>
      <li>
        👀 read: <a href="https://graphql.org/">GraphQL.org</a><br /><em
          >Let's be honest, nobody reads the full documentation first.</em
        >
      </li>
      <li>
        👀 read:
        <a href="https://www.apollographql.com/blog/getting-started-with-vue-apollo"
          >Getting started with Vue Apollo</a
        ><br /><em
          >And notice that it's outdated; so read it as information, not as instructions.</em
        >
      </li>
      <li>
        👀 read:
        <a href="https://v4.apollo.vuejs.org/guide-composable/setup.html">v4.apollo.vuejs.org</a
        ><br /><em>And notice the lack of script setup usage, don't regress.</em>
      </li>
    </ul>
    <h2>Installation</h2>
    <ol>
      <li>
        Install the
        <a href="https://addons.mozilla.org/en-US/firefox/addon/apollo-developer-tools/"
          >Apollo Client Devtools</a
        >
      </li>
      <li>
        Install the
        <a href="https://plugins.jetbrains.com/plugin/8097-graphql/"
          >GraphQL plugin for JetBrains IDEs or
          <a href="https://marketplace.visualstudio.com/items?itemName=GraphQL.vscode-graphql"
            >GraphQL LFS</a
          >
          for VSCode</a
        >
        <ol>
          <li>
            Create a graphql config file<br />
            <pre><code># graphql.config.yml

schema: local.graphql
extensions:
  endpoints:
      dev: ${VITE_API_URL}/graphql
</code></pre>
          </li>
          <li>
            For JetBrains: Get GraphQL schema from endpoint.<br />
            A file 'local.graphql' should be created.
            <figure><img src="/graphql_plugin.png" alt="" /></figure>
          </li>
        </ol>
      </li>
      <li>
        Create an instance of the apollo client under src/instances
        <pre><code>import { ApolloClient, createHttpLink, InMemoryCache } from '@apollo/client/core'

// HTTP connection to the API
const httpLink = createHttpLink({
  // You should use an absolute URL here
  uri: `${import.meta.env.VITE_API_URL}/graphql`,
})

// Cache implementation
const cache = new InMemoryCache()

// Create the apollo client
export const apolloClient = new ApolloClient({
  link: httpLink,
  cache,
})</code></pre>
      </li>
      <li>Provide the instance in main.ts
      <pre><code>// import ...
import { apolloClient } from '@/instances/apolloClient'

const app = createApp(App)
app.provide(DefaultApolloClient, apolloClient)

// use...
// mount...</code></pre></li>
    </ol>
  </main>
</template>

<style>
ol ol {
  margin-top: 1em;
}
</style>
